import processing.sound.*;

ArrayList<Kasten> kaesten;
Kasten currentKasten;
PImage lava; //image de la lave
float lavaY = height-200; //endroit de la lave
PImage nuage; //image nuage

color background;
color himmelFarbe;

int gameMode; //il y a le 0 -> rien et  1 (press on space = quadrat, der runter fällt)
int direction;
int level = 0;
int blockDurchmesser; //Durchmesser des carrés

float lavaSpeed; //rapidié à laquelle monte la lave
boolean lavaStarted; // la lave ne commence à monter seulement quand on appuie dur Space pour faire descendre le premier carré
float highestPoint;
float audioLast;

boolean isVictory = false;

SoundFile level1;
SoundFile level2;
SoundFile level3;
SoundFile level4;
SoundFile level5;
SoundFile richtig;
SoundFile wrong;
SoundFile victory;
SoundFile gameover;

void startGame() {
  frameRate(60);

  nuage = loadImage("./nuage.png"); //prendre du dossier?
  nuage.resize(int(nuage.width*0.5), int(nuage.height*0.5)); //changer la taille des images
  lava = loadImage("lava.png");
  lava.resize(int(lava.width*0.1), int(lava.height*0.1));
  kaesten = new ArrayList<Kasten>();
  currentKasten = new Kasten(200, 20, color(255, 0, 0));

  himmelFarbe = #119CF0;
  level = 3;
  gameMode = 0;
  direction = RIGHT;
  highestPoint = -1;
  changeLevel();
}


void gameAblauf() {
  background(background); //bleu
  image(nuage, 0, 0); //deux nuages
  image(nuage, 300, 40);
  rectMode(CORNER);
  fill(0);
  rect(0, 0, 200, 800);
  rect(800, 0, 200, 800);

  if (frameCount % 30 == 0) background = himmelFarbe;
  moveLava();
  steuerung();
  displayBlocks();
  if (lavaStarted && kaesten.size()>1) checkCollision(); //regarde si il y a collision seulement quand lavaStarted = true & kasten > 1???
}

void keyPressed() {
  if (key == ' ' && gameMode == 0) {
    gameMode=1;
    direction = RIGHT; //???
  }

  //if (key == 'd' && currentKasten.x < 800) currentKasten.x+=80;
}

void changeLevel() {
  level++;

  kaesten.clear(); //on enleve toutes les kaeten jusque là sur le jeu
  lavaY = -50; //la lave revient à sa place initiale--> plus en bas, car sinon, le jeu se termine tout de suite
  gameMode = 0; //game mode revient à 0-> il faut appuyer sur backspace pour le faire revenir à 1
  direction = RIGHT; //???
  lavaStarted = false; //la lave ne se met pas à bouger du moment que l'on a pas appuyer sur backspace

  lava = loadImage("lava.png");
  lava.resize(int(lava.width*0.1), int(lava.height*0.1));



  switch(level) { //les différents levels avec leurs différences
  case 1:
    blockDurchmesser = 50;
    lavaSpeed=0.2;
    level1.play();
    level1.loop();
    break;

  case 2:
    lavaSpeed = 0.4;
    level2.play();
    level1.stop();
    level2.loop();
    himmelFarbe = #1378F0;
    break;

  case 3:
    blockDurchmesser = 40;
    lavaSpeed=0.2;
    level2.stop();
    level3.play();
    level3.loop();
    himmelFarbe = #135BF0;
    break;

  case 4:
    blockDurchmesser = 30;
    lavaSpeed = 0.2;
    level3.stop();
    level4.play();
    level4.loop();
    himmelFarbe = #1613F0;
    break;
  case 5:
    level4.stop();
    level5.play();
    level5.loop();
    blockDurchmesser = 20;
    lavaSpeed = 0.04 ;
    himmelFarbe = #111083;
    break;
  case 6:
    level5.stop();
    isVictory = true;
    state = 2;
    if (!victory.isPlaying()) victory.play();
    stoppuhr = frameCount;

    break;
  }
}

void moveLava() { //pour faire bouger la lave
  if (!(lavaStarted)) return;
  for (int i = 0; i < (height-lavaY % lava.height); i++) { //la lave va vers le haut
    for (int k = 0; k < 3; k++) {
      image(lava, 200+k*lava.width, (height-lavaY)+lava.width*i);//???
    }
  }

  lavaY+=lavaSpeed;
}

void displayBlocks() {
  fill(0);
  rectMode(CORNER);
  square(currentKasten.x, currentKasten.y, blockDurchmesser); //current means-> celui utilisé et enregistré sur le moment
  for (Kasten k : kaesten) { //défini le k.x???
    square(k.x, k.y, blockDurchmesser); // le carré
  }
}

void steuerung() {
  switch(gameMode) {
  case 0:
    if (direction == RIGHT) {
      currentKasten.x+=6;
      if (currentKasten.x >= 800-blockDurchmesser) {
        direction = LEFT;
      }
    } else {
      currentKasten.x-=6;
      if (currentKasten.x <= 200) direction = RIGHT;
    }
    break;
  case 1:
    currentKasten.y+=10; //les coordonnées y du carré se déplacent vers le bas de 10 pixels
    if (keyPressed && keyCode == RIGHT && currentKasten.x+5 <= 800) currentKasten.x+=5; //se déplace à droite ou à gauche
    if (keyPressed && keyCode == LEFT && currentKasten.x-5 >= 200) currentKasten.x-=5;

    if (kaesten.size() > 0) {
      for (int i = 0; i < kaesten.size(); i++) {
        Kasten k = kaesten.get(i);

        boolean isYColliding = k.y == currentKasten.y+blockDurchmesser; // Schauen, ob der Spielerkasten auf Höhe des Kasten ist
        boolean isLeftColliding = currentKasten.x >= k.x && currentKasten.x < k.x+blockDurchmesser;
        boolean isRightColliding = currentKasten.x+blockDurchmesser >= k.x && currentKasten.x+blockDurchmesser < k.x+blockDurchmesser;

        if (k != currentKasten)
          if (isYColliding && (isLeftColliding || isRightColliding)) {
            kaesten.add(currentKasten);
            gameMode=0;

            if (highestPoint > currentKasten.y) highestPoint = currentKasten.y;

            currentKasten = new Kasten(200, 20, color(5, 0, 0)); //???
            currentKasten.y = 20;

            background = #1FAD69;
            if (!richtig.isPlaying()) richtig.play();

            //if(kaesten.get(kaesten.size()-1).y < 0) exit();
          } else if (currentKasten.y > height) { //fin du jeu-> on en vient à des levels différents
            gameMode = 0; //le gameMode revient à 0
            currentKasten = new Kasten(200, 20, color(255, 0, 0));  // Ein neuer Spieler wird erschaffen/erstellt
            currentKasten.y = 20; //le carré revient à 20
            background = color(255, 0, 0);
            if (!wrong.isPlaying()) wrong.play();
          }
      }
    } else if (currentKasten.y == height-blockDurchmesser) { // Falls es noch keinen ersten Kasten unten gibt, wird hier der Erste erstellt
      kaesten.add(currentKasten); // Kasten wechselt von Spieler zu Turmkasten

      highestPoint = currentKasten.y;
      lavaStarted = true; // Die Lava fängt nun an zu steigen
      currentKasten = new Kasten(200, 20, color(255, 0, 0)); // ein neuer spielerkasten wird erscahffen
      currentKasten.y = 20; // spielerkasten wird auf die richtige höhe gesetzt
      gameMode=0; // steuerungs-modus wechselt wieder auf 1


      background = #1FAD69;
      if (!richtig.isPlaying()) richtig.play();
    }

    break;
  }
}


void checkCollision() {

  if (kaesten.get(kaesten.size()-1).y  < 200) {
    background(#8AB760);
    textSize(40);
    text("Congratulation, you completed the level!!!", width/2, height/2);
    text("Press on r for the next level", width/2, height/2+70);

    if (key == 'r') {
      changeLevel();
    }
  } else
    if (highestPoint > (height-lavaY)) {
      state=2;
      level1.stop();
      level2.stop();
      level3.stop();
      level4.stop();
      level5.stop();
      if (!(gameover.isPlaying())) gameover.play();
      isVictory = false;
      stoppuhr = frameCount;
    }
}

class Kasten {
  float x, y;
  color c;

  Kasten(float x, float y, color c) {
    this.x = x;
    this.y = y;
    this.c = c;
  }
}
















// 0 200 800 1000
// 800 Höhe
// 0 200 800 1000

// Feld. 480'000 cm2
