float radius = 0;
color startColor = color(240, 128, 128);
color endColor = color(128, 128, 240);
PImage inspiration;
PFont urbanist;
int state;
int stoppuhr;

void setup() {
  size(1000, 800);
  background(0);
  strokeWeight(2);

  level1 = new SoundFile(this, "level1.wav");
  level2= new SoundFile(this, "level2.wav");
  level3 = new SoundFile(this, "level3.wav");
  level4 = new SoundFile(this, "level4.wav");
  level5 = new SoundFile(this, "level5.wav");
  richtig = new SoundFile(this, "richtig.wav");
  wrong = new SoundFile(this, "wrong.wav");
  victory = new SoundFile(this, "victory.wav");
  gameover = new SoundFile(this, "wrong.wav");
  urbanist = createFont("urbanist.ttf", 40);

  textFont(urbanist);

  state = 0;
}

void draw() {
  if (keyPressed) println(mouseX, mouseY);
  switch(state) {
  case 0:
    translate(width/2, height/2);
    float angleStep = TWO_PI/10;
    float angle = 0;

    for (int i = 0; i < 10; i++) { //Déclaration du variable
      float t = map(i, 0, 9, 0, 1);
      color strokeColor = lerpColor(startColor, endColor, t);
      stroke(strokeColor);
      float x1 = cos(angle + i*angleStep) * radius;
      float y1 = sin(angle + i*angleStep) * radius;
      float x2 = cos(angle + (i+1)*angleStep) * radius;
      float y2 = sin(angle + (i+1)*angleStep) * radius;
      line(x1, y1, x2, y2);
    }

    frameRate(1000);
    radius += 3;

    //TEXT
    fill(225);
    textAlign(CENTER);
    textSize(30);
    text("Welcome to", 200, 100);
    textSize(50);
    text("Tetris- City", 200, 150);

    textSize(25);
    fill(255);
    text("Press <i> to see the instructions", 200, 250);



    //INSTRUCTION PAGE
    if (key == 'i') {
      background(0);
      inspiration = loadImage("inspiration.jpg");
      inspiration.resize(int(inspiration.width*2), int(inspiration.height*2));
      imageMode(CORNER);
      image(inspiration, -700, -250);
      rectMode(CENTER);

      rectMode(CORNER);
      fill(255);
      strokeWeight(3);
      stroke(255);
      rect(0, 0, 1000, 720);
      rectMode(CENTER);

      textAlign(LEFT);
      fill(0);
      textSize(45);
      text("INFOPAGE", 20, 100);
      textSize(25);
      text("- use the arrow keys to move the block left and right", 20, 170);
      text("- you receive rewards for completing a level", 20, 230);
      text("- complete the level in time", 20, 290);
      text("Press <s> to start!", 20, 290+60);

      fill(255);
      textSize(60);
      textAlign(CENTER);
      text("Press <s> to start", 350, 450);
      textSize(40);
      text("Good Luck!!!", 500, 650);
    }

    //GAMME
    if (key == 's') {
      background(0);
      state++;
      startGame();
    }
    break;
  case 1:
    gameAblauf();
    break;
  case 2:

    if (isVictory) {
      background(0, 255, 0);
      textSize(80);
      textAlign(CENTER);
      fill(#FFFFFF);
      text("DU HAST GEWONNEN!", width/2, height/2);
    } else {
      background(255, 0, 0);
      textSize(90);
      textAlign(CENTER);
      fill(#FFFFFF);
      text("DU HAST VERLOREN!", width/2, height/2);
    }

    if (stoppuhr/60f + 4 < frameCount/60f) {
      background(0);
      state = 0;
      radius = 0;
    }
    break;
  }
}
